/*
	Silky's Marine Buster / Koihime
	ELF Effect(SE)
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned int	file_count = 0;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			out_filename[256];
	char			filename[12];
	int				i = 0;
	unsigned long	file_tbl[80];

	printf( "Silky's BGM.MDT Divider 100219 (c)KUROHANE Works\n" );

	if( ac == 1 )
	{
		printf( "usage: MDTDIV <filename> <filename_prefix> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* Read Header */
	buf = ( unsigned char * )calloc( 1, 0x100 );
	fread( buf, 0x100, 1, in );

	/* file_tbl */
	memset( file_tbl, 0, sizeof( file_tbl ));
	for( i = 0; i != 0x100; i += 2 )
	{
		unsigned long	tmp;

		tmp = *( unsigned int *)( buf + i );
		if( tmp != 0 )
		{
			file_tbl[file_count] = tmp;
			file_count++;
		}
	}
	file_tbl[file_count] = file_ed;

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		header_filest = file_tbl[i];
		header_fileed = file_tbl[i+1];
		header_filesize = header_fileed - header_filest;

		if( file_count == 1 )
		{
			switch( ac )
			{
				case 2:
					sprintf( out_filename, "BGM.M", i );
					sprintf( filename, "BGM.M", i );
					break;
				case 3:
					sprintf( out_filename, "%s.M", av[2], i );
					sprintf( filename, "%s.M", av[2], i );
					break;
				case 4:
					sprintf( out_filename, "%s%s.M", av[3], av[2], i );
					sprintf( filename, "%s.M", av[2], i );
					break;
			}
		} else {
			switch( ac )
			{
				case 2:
					sprintf( out_filename, "BGM_%02d.M", i );
					sprintf( filename, "BGM_%02d.M", i );
					break;
				case 3:
					sprintf( out_filename, "%s_%02d.M", av[2], i );
					sprintf( filename, "%s_%02d.M", av[2], i );
					break;
				case 4:
					sprintf( out_filename, "%s%s_%02d.M", av[3], av[2], i );
					sprintf( filename, "%s_%02d.M", av[2], i );
					break;
			}
		}

		printf( "%s %04lX-%04lX (%lu)\n",
			filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, header_filesize );

		fseek( in, header_filest, SEEK_SET );
		fread( filebuf, header_filesize, 1, in );
		fwrite( filebuf, header_filesize, 1, out );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
